library otp_auth_alert_widget;

import 'package:flutter/material.dart';
class OTPAlertBox extends StatefulWidget {

  @override
  _OTPAlertBoxState createState() => _OTPAlertBoxState();
}

class _OTPAlertBoxState extends State<OTPAlertBox> {
  final String? alertTitle;
  final String? conformButtonText;
  final int? numberOfDigit;
  final TextDirection? textDirection;
  final int? timeOut;
  final String? timeOutText;
  final VoidCallback? onConformButtonPressed;
  final Color? conformButtonColor;
  final Color? conformButtonTextColor;
  List<Widget>? listOfDigit;
  List<String>? listOfNumbers;
  _OTPAlertBoxState({ this.alertTitle, this.conformButtonText, this.numberOfDigit, this.textDirection, this.timeOut, this.timeOutText, this.onConformButtonPressed, this.conformButtonColor, this.conformButtonTextColor});
  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    listOfNumbers = new List<String>.filled(numberOfDigit!, "0",growable: false);
    for(int i =0 ; i<numberOfDigit!; i++){
      listOfDigit!.add(new digitContanier());
    }
  }
  @override
  Widget build(BuildContext context) {
    var size = MediaQuery.of(context).size;
    return AlertDialog(
      title: Text(
        alertTitle!,
        textDirection: TextDirection.rtl,
        textAlign: TextAlign.start,
        style: TextStyle(
            fontSize: size.width * 0.06520,
            color: Colors.black,
            fontWeight: FontWeight.bold),
      ),
      content: Container(
        width: size.width * 0.75,
        height: size.height * 0.25,
        child: Column(
          // mainAxisSize: MainAxisSize.max,
          mainAxisAlignment: MainAxisAlignment.spaceEvenly,
          children: [
            Row(
              mainAxisAlignment: MainAxisAlignment.center,
              children: listOfDigit!
            ),
            TextButton(
                onPressed: onConformButtonPressed!,
                style: ButtonStyle(
                  overlayColor: MaterialStateColor.resolveWith(
                          (states) => Colors.transparent),
                ),
                child: Container(
                  alignment: Alignment.center,
                  width: size.width * 0.4,
                  height: size.height * 0.07,
                  decoration: BoxDecoration(
                      borderRadius:
                      new BorderRadius.circular(10.0),
                      color: conformButtonColor!),
                  child: Text(
                    conformButtonText!,
                    textDirection: TextDirection.rtl,
                    style: TextStyle(
                        fontSize: size.width * 0.05,
                        color: conformButtonTextColor!,
                        fontWeight: FontWeight.bold),
                  ),
                )),
            Row(
              mainAxisAlignment: MainAxisAlignment.end,
              children: [
                TweenAnimationBuilder<Duration>(
                    duration: Duration(seconds: timeOut!),
                    tween: Tween(
                        begin: Duration(seconds: timeOut!),
                        end: Duration.zero),
                    onEnd: () {},
                    builder: (BuildContext context,
                        Duration value, Widget? child) {
                      final seconds = value.inSeconds;
                      return Padding(
                          padding: const EdgeInsets.symmetric(
                              vertical: 5),
                          child: Text('$seconds',
                              textAlign: TextAlign.center,
                              style: TextStyle(
                                  color: Colors.black,
                                  fontWeight: FontWeight.bold,
                                  fontSize: 18)));
                    }),
                Text(
                  timeOutText!,
                  style: TextStyle(
                    fontSize: 18,
                    color: Colors.black,
                    fontWeight: FontWeight.bold,
                  ),
                )
              ],
            )
          ],
        ),
      ),
    );
  }
}

class digitContanier extends StatelessWidget {
  TextEditingController _controllerDiget = TextEditingController();
  String degitNumber = '';
  @override
  Widget build(BuildContext context) {
    var size = MediaQuery.of(context).size;
    return Padding(
      padding: const EdgeInsets.all(8.0),
      child: Container(
        alignment: Alignment.center,
        width: size.width * 0.1,
        child: TextFormField(
          keyboardType: TextInputType.number,
          controller: _controllerDiget,
          maxLength: 1,
          autofocus: true,
          textAlign: TextAlign.center,
          textDirection: TextDirection.rtl,
          textInputAction: TextInputAction.next,
          onChanged: (v) {
            degitNumber = v;
            FocusScope.of(context).nextFocus();
          },
          decoration: InputDecoration(
            counterText: "",
            enabledBorder: OutlineInputBorder(
                borderSide: BorderSide(
                    color: Colors.black87, width: 1)),
            disabledBorder: OutlineInputBorder(
                borderSide: BorderSide(
                    color: Colors.black87, width: 1)),
            errorBorder: OutlineInputBorder(
                borderSide: BorderSide(
                    color: Colors.red, width: 1)),
            focusedBorder: OutlineInputBorder(
                borderSide: BorderSide(
                    color: Colors.green, width: 1)),
            border: InputBorder.none,
          ),
        ),
      ),
    );
  }
}





